
/* template.c - your comments here */

#ifndef	lint
static char *rcsid = "$Header: /xtel/isode/isode/others/quipu/uips/de/RCS/init.c,v 8.1 1991/09/13 14:36:41 isode Exp $";
#endif

/* 
 * $Header: /xtel/isode/isode/others/quipu/uips/de/RCS/init.c,v 8.1 1991/09/13 14:36:41 isode Exp $
 *
 *
 * $Log: init.c,v $
 * Revision 8.1  1991/09/13  14:36:41  isode
 * PARADISE Upgrade release
 *
 * Revision 8.0  91/07/17  13:18:42  isode
 * Release 7.0
 * 
 * 
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */


/****************************************************************************

  init.c - Do some initialising
           Read tailor files
           Eventually do argument parsing

*****************************************************************************/

/* #include <stdlib.h> */
#include <ctype.h>

#include "types.h"
#include "util.h"
#include <isode/quipu/util.h>
#include <isode/tailor.h>
#include <isode/logger.h>
#include "bulkloadglobal.h"
#include "configuration.h"

static dsaAddFound = FALSE;

extern int print_parse_errors;          /* Quipu variable to disable
                                           printing of errors */

extern LLog * bulkload_log ;
extern int bulkloadLogLevel ;

extern char *oidtable,   /* Name of oidtable to use */
            *tailfile,   /* Name of dsaptailor file to use*/
            *username,
  	    *dsa_address,
	    *password,
            *backup_dsa_address,
  	    *local_dit;

extern int preferInvVideo;
extern int greyBook;
extern int browseMess;
extern int localAlarmTime;
extern int remoteAlarmTime;
extern int bindTimeout;
extern int quitChars;
extern int wanAccess;
extern int deptQ;

extern char callingDteNumber[],
	    origDefaultCo[], 
	    origDefaultOrg[],
            welcomeMessage[];


extern  struct	bulkLoadConfigStruct 	bulkLoadConfig ;
extern  struct	managementConfigStruct 	managementConfig ;


static void read_bulkload_option();



int initialisations( argc, argv, operModep, fileBufferp, managementModep )
int	argc ;
char *	argv[] ;
int  *	operModep ;
char *	fileBufferp ;
int  *	managementModep ;
{
FILE *config_file = (FILE *)NULL, *quipurcfp = (FILE *)NULL ;
char linebuf[SMALLBUFLEN], dishHome[SMALLBUFLEN], *homecp=NULLCP, *cp, *configFilecp = NULLCP ;
void de_exit();

  initManagementConfigurations( TRUE ) ;
  initBulkLoadConfigurations( TRUE );

  print_parse_errors = FALSE;   /* Stop auto printing of errors */


#ifndef PPANDDLUNAVAILABLE
  sys_init(argv[0]);
  or_myinit();
#endif

  quipu_syntaxes();

#ifndef PPANDDLUNAVAILABLE
  pp_syntaxes();
#endif

  username = NULLCP;
  password = NULLCP;

  /* Process the run time arguments.. */
  for (argc--, argv++; argc > 0; )
  {
    cp = *argv;
    
    if (*cp != '-')
    {	
	/* Assume is is the input file name */

	strcpy( fileBufferp, *argv );	

	argc-- ;
	argv++ ;
    }
    else {

      switch (tolower(*++cp))
      {
      	case 'd':
	  argc--;
	  argv++;

	  bulkLoadConfig.disableBulkAttributeUsage = TRUE ;

	  fprintf( stderr, "BULK LOAD SPECIFIC ATTRIBUTES DISABLED\n" ) ;
	  
	  break ;
	  
      	case 'u':
	  argc--;
	  argv++;

	  if( *argv != NULLCP )
 		username = copy_string( *argv ) ;
	  else
	  {
	  	fprintf( stderr, "Fatal Error missing user name parameter value\n" ) ;
		de_exit( -1 ) ;
	  }

	  argc--;
	  argv++;

	  break ;
	  
      	case 'p':
	  argc--;
	  argv++;

	  if( *argv != NULLCP )
 		password = copy_string( *argv ) ;
	  else
	  {
	  	fprintf( stderr, "Fatal Error missing password parameter value\n" ) ;
		de_exit( -1 ) ;
	  }

	  argc--;
	  argv++;

	  break ;
	  
	case 'm':
	  argc--;
	  argv++;

	  *managementModep = TRUE ;
	  
	  break ;
	  
	case 't': /* Tailor file */
	  argc--;
	  argv++;

	  if( *argv != NULLCP )
 		configFilecp = copy_string( *argv ) ;
	  else
	  {
	  	fprintf( stderr, "Fatal Error missing tailor file parameter value\n" ) ;
		de_exit( -1 ) ;
	  }

	  argc--;
	  argv++;

	  break ;
      
	case 'e': /* Updates to Existing entries */
	  argc--;
	  argv++;

	  bulkLoadConfig.updatesToExistingEntries = TRUE ;

	  break ;
	  
 	case 'o': /* operational mode */
	  argc--;
	  argv++;

          if( tolower( **argv ) == INTERACTIVE_CHAR )
	    *operModep = INTERACT_OPER_MODE ;
	  else if( tolower( **argv ) == NON_INTERACTIVE_CHAR )
	    *operModep = NON_INTERACT_OPER_MODE ;

	  argc-- ;
	  argv++ ;
	  
	  break ;

	case 'f': /* Input file name */
	  argc--;
	  argv++;

	  strcpy( fileBufferp, *argv );

	  argc-- ;
	  argv++ ;
	  
	  break ;	  

        case 'h':
	  argc--;
	  argv++;
	  if (argv != (char **)NULL)
	  {
	    (void) strcpy(callingDteNumber, *argv);
	    argc--;
	    argv++;
	  }
	  else
	    (void) strcpy(callingDteNumber, "");

	  break;

	default:


	  argc--;
	  argv++;
	  
	  fprintf( stderr, "Warning unsupported parameter %s\n" , *argv ) ;

	  /* skip parameter.. */
	  argc-- ;
	  argv++ ;

	  break ;
      }
    }
  }


  AlgoNameSyntaxHandler() ;

  /* Initialize dsap library. */

  dsap_init((int *)NULL, (char ***)NULL) ;

  specialSyntaxHandlers() ;


#ifndef PPANDDLUNAVAILABLE
  pp_quipu_run();
#endif

  backup_dsa_address = NULLCP;

  /* Read in dsaptailor file */
  if ((config_file = fopen( isodefile( tailfile, 0), "r")) == (FILE *) NULL) {
    (void) fprintf(stderr,
            "Cannot open `dsaptailor' file. Attempting to continue.\n");
  } else {
    while(fgets(linebuf, sizeof(linebuf), config_file) != NULLCP)
      if ((*linebuf != '#') && (*linebuf != '\n')) (void) tai_string (linebuf);

    (void) fclose(config_file);
  }
  
  /* turn off logging that we are not interested in */
  (void) isodesetvar("compatlevel", "none", 0);
  (void) isodesetvar("addrlevel", "none", 0);
  (void) isodesetvar("tsaplevel", "none", 0);
  (void) isodesetvar("ssaplevel", "none", 0);
  (void) isodesetvar("psaplevel", "none", 0);
/*  (void) isodesetvar("psapfile", "/tmp/psaplog", 0); PURIFY ERROR */
  (void) isodesetvar("psap2level", "none", 0);
/*  (void) isodesetvar("psap2file", "/tmp/psap2log", 0); PURIFY ERROR */
  (void) isodesetvar("acsaplevel", "none", 0);
  (void) isodesetvar("rosaplevel", "none", 0);

  isodexport("bulkload");  

  /* Check for a command line tailor file request first.. */
  if( configFilecp != NULLCP ) {

    if ((config_file = fopen( configFilecp, "r")) == (FILE *) NULL)
    {
      (void) fprintf(stderr, "Cannot open `%s' file fatal error.\n", configFilecp);
      de_exit( -1 ) ;
    }  
  } 
  else if ((config_file = fopen( isodefile( "bulk/bulkloadtailor", 0), "r")) == (FILE *) NULL) 
  {
    (void) fprintf(stderr, "Cannot open `bulkloadtailor' file fatal error.\n");
    de_exit( -1 ) ;
  } 

  if( config_file != (FILE *)NULL )
  {
    while(fgets(linebuf, sizeof(linebuf), config_file) != NULLCP)
    {
      if ((*linebuf != '#') && (*linebuf != '\n'))
        read_bulkload_option(linebuf);
    }
    
    (void) fclose(config_file);
  }


  /* Check if the password and user name parameters have been read.. */
  if( password == NULLCP || username == NULLCP )
  {
    /* Try the ".quipurc" file.. */
    
    if (homecp = getenv ("QUIPURC"))
      (void) strcpy (dishHome, homecp) ;

    else if (homecp = getenv ("HOME"))
      (void) sprintf (dishHome, "%s/.quipurc", homecp);

    else (void) strcpy (dishHome, "./.quipurc");
									   
    if( (quipurcfp = fopen( dishHome, "r" )) != (FILE *)NULL )
    {
	fprintf( stderr, "Trying %s for `password' and `username'\n", dishHome ) ;
    	
	/* Find the missing statement(s).. */
    	while((password == NULLCP || username == NULLCP) &&
	       fgets(linebuf, sizeof(linebuf), config_file) != NULLCP)
	{
          if ((*linebuf != '#') && (*linebuf != '\n')) 
	    read_bulkload_option(linebuf);
	}

        (void) fclose( quipurcfp );
    }
  }

  (void) printf("%*s%s\n\n", (80 - (int)strlen(welcomeMessage)) / 2, "", 
                welcomeMessage);

  initVideo();

  return OK;
}

/*
 * - read_bulkload_option() -
 *
 * Read in an option from bulkloadtailor file.
 */
static void read_bulkload_option(line)
     char *line;
{
char *part1, *part2;
extern char *TidyString(), *SkipSpace();
int n;

  part1 = SkipSpace(line);
  
  if ((part2 = index(part1, ':')) == NULLCP) return;

  *part2++ = '\0';
  part2 = TidyString(part2);

  if (lexequ(part1, "welcomeMessage") == 0) {
    (void) strcpy(welcomeMessage, part2);
  }
  else if (lexequ(part1, "dsa_address") == 0) {

    if (dsaAddFound == FALSE)
    {
      dsa_address = copy_string(part2);
#ifdef DEBUG
fprintf( stderr, "DSA load %s\n", dsa_address ) ;
#endif
      dsaAddFound = TRUE;
    }
    else if (backup_dsa_address == NULLCP)
      backup_dsa_address = copy_string(part2);
  }
  else if (lexequ(part1, "username") == 0) {
    if( username == NULLCP )
    	username =  copy_string(part2);
  }
  else if (lexequ(part1, "password") == 0) {
    if( password == NULLCP )
	password =  copy_string(part2);
  }
  else if (lexequ(part1, "bulkloadlogfile") == 0) {
    bulkload_log->ll_file = copy_string(part2);
  }
  else if (lexequ(part1, "inverseVideo") == 0) {
    if (lexequ(part2, "off") == 0)
      preferInvVideo = FALSE;
    else
      preferInvVideo = TRUE;
  }
  else if (lexequ(part1, "greyBook") == 0) {
    if (lexequ(part2, "off") == 0)
      greyBook = FALSE;
    else
      greyBook = TRUE;
  }
  else if (lexequ(part1, "browseMess") == 0) {
    if (lexequ(part2, "off") == 0)
      browseMess = FALSE;
    else
      browseMess = TRUE;
  }
  else if (lexequ(part1, "wanAccess") == 0) {
    if (lexequ(part2, "off") == 0)
      wanAccess = FALSE;
    else
      wanAccess = TRUE;
  }
  else if (lexequ(part1, "localAlarmTime") == 0) {
    n = atoi(part2);
    if (n > 0)
      localAlarmTime = n;
  }
  else if (lexequ(part1, "remoteAlarmTime") == 0) {
    n = atoi(part2);
    if (n > 0)
      remoteAlarmTime = n;
  }
  else if (lexequ(part1, "bindTimeout") == 0) {
    n = atoi(part2);
    if (n > 0)
      bindTimeout = n;
  }
  else if (lexequ(part1, "quitChars") == 0) {
    n = atoi(part2);
    if (n > 0)
      quitChars = n;
  }
  else if (lexequ(part1, "logLevel") == 0) {
    bulkloadLogLevel = atoi(part2);
  }
  else if( processManagementConfigLine( part1, part2, NULLCP ) == FALSE )
    (void)processBulkLoadConfigLine( part1, part2, NULLCP ) ; /* Will remove spaces from left and tight tokens */
  
} /* read_bulkload_option */



welcome()
{
FILE * welcome_file;
char linebuf[SMALLBUFLEN];

  if ((welcome_file = fopen( isodefile( "bulk/bulkloadwelcome", 0), "r")) == (FILE *) NULL)
    (void) fprintf(stderr,
            "Cannot open `bulkloadwelcome' file. Attempting to continue.\n");
  else 
  {
    resetprint( "" );
    
    while(fgets(linebuf, sizeof(linebuf), welcome_file) != NULLCP)
	pageprint( linebuf );
	
    (void) fclose(welcome_file);
  }
}
