#include <isode/quipu/util.h>
#include <isode/quipu/dua.h>
#include <isode/quipu/ds_error.h>


int
attemptReferralBind( cr_acsptp )
ContinuationRef	cr_acsptp ;
{
int	referralSucceeded = FALSE, unbound = FALSE ;
struct  access_point  * acsptp ;

	for( ;
	     cr_acsptp != (ContinuationRef)NULL && referralSucceeded == FALSE ;
	     cr_acsptp =  cr_acsptp -> cr_next )
	{
	    for(acsptp =  cr_acsptp -> cr_accesspoints ;
		acsptp != (struct access_point *)NULL && acsptp -> ap_address != (struct PSAPaddr *)NULL
			&& referralSucceeded == FALSE ;
		acsptp =  acsptp -> ap_next )
	    {
		startUnbindTimer() ;

		if( unbound == FALSE )
		    (void)de_unbind() ;

		if( de_referral_bind( acsptp -> ap_address ) == OK )
		{
		    stopUnbindTimer() ;
		    referralSucceeded = TRUE ;
		    break ;
		}
		else
 		{
		    stopUnbindTimer() ;
		    unbound = TRUE ;
		}
	    }
	}

	if( unbound == TRUE )
	    (void)de_bind( TRUE ) ; /* rebind to the default DSA */
	    
	return( referralSucceeded ) ;
}


/*
 * If a directory request requires a referral, bind to the specified DSA
 * and indicate that the request should be retried..
 */

int
referralToBeProcessed( DAPrequestRetVal, errorp )
int	DAPrequestRetVal ;
struct	DSError * errorp ;
{
int	referralRequestToBeRetried = FALSE, referralSucceeded = FALSE ;
	
	if( DAPrequestRetVal == DS_ERROR_REMOTE && 
		(errorp -> dse_type == DSE_REFERRAL || errorp -> dse_type == DSE_DSAREFERRAL ) )
	{
	    referralSucceeded = attemptReferralBind( errorp -> dse_un.dse_un_referral.DSE_ref_candidates ) ;

	    if( referralSucceeded == TRUE )
	    {
		referralRequestToBeRetried = TRUE ;
		ds_error_free( errorp ) ;
	    }
	}

	return( referralRequestToBeRetried ) ;
}
